  -- About GOBI.lua
--
-- GOBI.lua does an GOBI search for the ISBN for loans.
-- scriptActive must be set to true for the script to run.
-- autoSearch (boolean) determines whether the search is performed automatically when a request is opened or not.
--


-- set autoSearch to true for this script to automatically run the search when the request is opened.
local autoSearch = GetSetting("AutoSearch");
local account= GetSetting("Account");
local username= GetSetting("Username");
local password= GetSetting("Password");

local interfaceMngr = nil;
local browser = nil;

function Init()
	if GetFieldValue("Item", "ItemType") == "MON" then
    interfaceMngr = GetInterfaceManager();

    -- Create a form
    form = interfaceMngr:CreateForm("GOBI", "Script");

    -- Add a browser
    browser = form:CreateBrowser("GOBI", "GOBI", "GOBI");

    -- Hide the text label
    browser.TextVisible = false;

    -- Since we didn't create a ribbon explicitly before creating our browser, it will have created one using the name we passed the CreateBrowser method.  We can retrieve that one and add our buttons to it.
    ribbonPage = form:GetRibbonPage("GOBI");
    
    -- Create the search and import buttons.  We are storing the import button so we can enable it and disable it as needed.
    ribbonPage:CreateButton("Search", GetClientImage("Search32"), "Search", "GOBI");

    -- After we add all of our buttons and form elements, we can show the form.
    form:LoadLayout("GOBILayout.xml");
    form:Show();

    if autoSearch then
      Search();
    end
	end
end

function Search()
	browser:RegisterPageHandler("formExists", "loginForm", "GOBILoaded", false);
	browser:Navigate("http://www.gobi3.com/Pages/Login.aspx");	
end

function GOBILoaded()
	browser:SetFormValue("loginForm", "gbase", account);
	browser:SetFormValue("loginForm", "guser", username);
	browser:SetFormValue("loginForm", "gpword", password);
	browser:SubmitForm("loginForm");
	browser:RegisterPageHandler("formExists", "basicsearchform", "StartSearch", false);
  
end

function StartSearch()
  local isXn = GetFieldValue("Item", "ISXN");
  local title = GetFieldValue("Item", "Title");

  local SearchType = browser:GetElementInFrame(nil, "basicsearchinputtype");

	if isXn ~= nil and isXn:len()>=8 then    
    SearchType:SetAttribute("Value","Isbn");
    browser:SetFormValue("basicsearchform", "basicsearchinput", isXn);
    browser:ClickObject("basicsearchsubmit");
	elseif title ~= nil then
    SearchType:SetAttribute("Value","Title");
    browser:SetFormValue("basicsearchform", "basicsearchinput", title);
    browser:ClickObject("basicsearchsubmit");
	end
end

