-- About HathitTrust.lua
--
-- This Addon does an ISBN or Title search using Hathi Trust (http://www.hathitrust.org).
-- ISBN will be run if one is available.
-- scriptActive must be set to true for the script to run.
-- autoSearch (boolean) determines whether the search is performed automatically when a request is opened or not.
--


-- set autoSearch to true for this script to automatically run the search when the request is opened.
local autoSearch = GetSetting("AutoSearch");
local interfaceMngr = nil;
local form = nil;
local ribbonPage = nil;
local browser = nil;

function Init()
	if GetFieldValue("Item", "ItemType") == "MON" then
		interfaceMngr = GetInterfaceManager();
				
		-- Create a form
		form = interfaceMngr:CreateForm("Hathi", "Script");
		
		-- Add a browser
		browser = form:CreateBrowser("Hathi", "Hathi", "Hathi");
		
		-- Hide the text label
		browser.TextVisible = false;
		
		-- Since we didn't create a ribbon explicitly before creating our browser, it will have created one using the name we passed the CreateBrowser method.  We can retrieve that one and add our buttons to it.
		ribbonPage = form:GetRibbonPage("Hathi");
		
		-- Create the search and import buttons.  We are storing the import button so we can enable it and disable it as needed.
		ribbonPage:CreateButton("Search", GetClientImage("Search32"), "Search", "Hathi");
		
		-- After we add all of our buttons and form elements, we can show the form.
		form:LoadLayout("HathiLayout.xml");
		form:Show();

        
		if autoSearch then
			  Search();
   		end
	end
end

function Search()
	local isxn = GetFieldValue("Item", "ISXN");
	local title = GetFieldValue("Item", "Title");
	
	local urlParams = "";

	if isxn ~= nil and isxn ~= "" then
		urlParams = "checkspelling=true&type=all&lookfor=" .. isxn .. "&submit=&type=isn&sethtftonly=true"	
		browser:Navigate("http://catalog.hathitrust.org/Search/Home?" .. urlParams);
	elseif title ~= nil and title ~= "" then
		urlParams = "checkspelling=true&type=all&lookfor=" .. title .. "&submit=&type=title&sethtftonly=true"	
		browser:Navigate("http://catalog.hathitrust.org/Search/Home?" .. urlParams);
	end	
end